function BasicAudioController(){
  
  var self = this; self.name = "BasicAudioController"; // MANDATORY
  this.driver = null;
  
  this.loadDriver = function ( platform ) { return };
  
  this.init = function ( volume ){
    console.log("AUDIO# Init BAsic Controller")
    self.driver = self.loadDriver();
    self.driver.init ( volume )
    return true;
  };  
  
  this.resetDefaultAudioOptions = function(volume){
    self.driver.resetDefaultAudioOptions(volume);
  };
  
  this.addAudioConfig = function(options){
    self.driver.addAudioConfig(options);
  };
  
  this.getDefaultAudioOptions = function(){
    return self.driver.getDefaultAudioOptions();
  };
  
  this.setDefaultAudioOptions = function(options){
    self.driver.setDefaultAudioOptions(options);
  };
  
  this.setAudioOptions = function(options,audioObj){
    return self.driver.setAudioOptions(options,audioObj);
  };
  
  this.refreshAudioOutput = function(audioObj,options,source){
    self.driver.refreshAudioOutput(audioObj,options,source);
  };
  
  this.connectAudioOutput = function(source,options){
    return self.driver.connectAudioOutput(source,options);
  };
  
  this.disconnectAudioOutput = function(audioObj){
    return self.driver.disconnectAudioOutput(audioObj);
  };
  
  this.unload = function(){
    self.driver.unload();
  };
}

BasicAudioController.prototype = new SystemController();
