function KeyboardController(client){
	var self = this; self.name = "KeyboardController"; // MANDATORY

    this.keyboardShift = false;
		this.keyboardCtrl = false;
    this.client = client;
       
		$(window).keypress(function(event){
        var keyCode = 0;
				var codeAt = 0;
				try{
					codeAt = event.key.charCodeAt(0);
				}catch(e){
					//avoid
				}
				
        if(codeAt > 0){
            keyCode = event.key.charCodeAt(0);
        }else{
            keyCode = event.which;
        }
        self.wrapKeyPress(keyCode,self.keyboardShifted,self.keyboardCtrl);
    });  

    $(window).on("keyup",function(event) {
        if(event.which == 16) {
            self.keyboardShift = false;
        }
				if(event.which == 17) {
            self.keyboardCtrl = false;
        }
        self.wrapKeyUp(event.which,self.keyboardShift,self.keyboardCtrl);
    });

    $(window).on("keydown",function(event) {
        if(event.which == 16) {
            self.keyboardShift = true;
        }    
				if(event.which == 17) {
						self.keyboardCtrl = true;
				}    
        self.wrapKeyDown(event.which,self.keyboardShift,self.keyboardCtrl);
    });
    
    this.wrapKeyUp = function(keyCode,shifted,ctrl){      
        if(typeof(self.client) !== 'undefined'){
            if(typeof(self.client.keyUp) !== 'undefined'){
                self.client.keyUp(keyCode,shifted,ctrl);
            }
        }
    };
    
    this.wrapKeyDown = function(keyCode,shifted,ctrl){       
        if(typeof(self.client) !== 'undefined'){
            if(typeof(self.client.keyDown) !== 'undefined'){
                self.client.keyDown(keyCode,shifted,ctrl);
            }
        }
    };
    
    this.wrapKeyPress = function(keyCode,shifted,ctrl){       
        if(typeof(self.client) !== 'undefined'){
            if(typeof(self.client.keyPress) !== 'undefined'){
                self.client.keyPress(keyCode,shifted,ctrl);
            }
        }
    };
    
}	
KeyboardController.prototype = new SystemController();
    
